

##Simulation results (Section 9)
I = list()
for(k in 1:10){
    load(paste("~/Revision Code/Sims/FullSimBayesI",k,".rda"))
  I[[k]]<-list()  
  for(i in 1:4){I[[k]][[i]] <- array(dim=c(2,2,5,5))}
  s2n_indvec = c(rep(1,5),rep(2,5))
  lambda_indVec = rep(c(1,2,3,4,5),2)
  for(j in 1:10){
    s2n_ind = s2n_indvec[j]
    lambda_ind = lambda_indVec[j]
    for(i in 1:4){
      I[[k]][[i]][,s2n_ind,lambda_ind,]=All[[j]][[i]][,s2n_ind,lambda_ind,]
    }  
  }
}

AllSums = I[[1]][[1]]
for(i in 2:10){
  AllSums = AllSums+I[[i]][[1]]
}
AllMeans = AllSums/10

####Mean error for correct ranks
rowMeans(AllMeans[2,2,,]) ###error increasing with regularization
rowMeans(AllMeans[2,1,,]) ###No substantive differences
rowMeans(AllMeans[1, 1,,])##error decreasing with regularization
rowMeans(AllMeans[1, 2,,])

##SD's,
means = array(dim=c(4,5,10))

for(i in 1:10){
  blah1 = rowMeans(I[[i]][[1]][1,1,,])
  blah2 = rowMeans(I[[i]][[1]][1,2,,])
  blah3 = rowMeans(I[[i]][[1]][2,1,,])
  blah4 = rowMeans(I[[i]][[1]][2,2,,])
  for(l in 1:5){
    means[1,l,i] = blah1[l]
    means[2,l,i] = blah2[l]
    means[3,l,i] = blah3[l]
    means[4,l,i] = blah4[l]
  }
}
##standard errors
apply(means,c(1,2),sd)/sqrt(10)

####Correlated E results (Section D)
I = list()
for(k in 1:10){
  load(paste("~/Revision Code/Sims/FullSimBayesCorYI",k,".rda"))
  I[[k]]<-list()  
  for(i in 1:4){I[[k]][[i]] <- array(dim=c(2,2,5,5))}
  s2n_indvec = c(rep(1,5),rep(2,5))
  lambda_indVec = rep(c(1,2,3,4,5),2)
  for(j in 1:10){
    s2n_ind = s2n_indvec[j]
    lambda_ind = lambda_indVec[j]
    for(i in 1:4){
      I[[k]][[i]][,s2n_ind,lambda_ind,]=All[[j]][[i]][,s2n_ind,lambda_ind,]
    }  
  }
}

AllSums = I[[1]][[1]]
for(i in 2:10){
  AllSums = AllSums+I[[i]][[1]]
}
AllMeans = AllSums/10

####Mean error for correct ranks
rowMeans(AllMeans[2,2,,]) ###error increasing with regularization
rowMeans(AllMeans[2,1,,]) ###No substantive differences
rowMeans(AllMeans[1, 1,,])##error decreasing with regularization
rowMeans(AllMeans[1, 2,,])

##SD's,
means = array(dim=c(4,5,10))

for(i in 1:10){
  blah1 = rowMeans(I[[i]][[1]][1,1,,])
  blah2 = rowMeans(I[[i]][[1]][1,2,,])
  blah3 = rowMeans(I[[i]][[1]][2,1,,])
  blah4 = rowMeans(I[[i]][[1]][2,2,,])
  for(l in 1:5){
    means[1,l,i] = blah1[l]
    means[2,l,i] = blah2[l]
    means[3,l,i] = blah3[l]
    means[4,l,i] = blah4[l]
  }
}
##standard errors
apply(means,c(1,2),sd)/sqrt(10)

####Correlated X results (Section D)
I = list()
for(k in 1:10){
  load(paste("~/Revision Code/Sims/FullSimBayesCorXI",k,".rda"))
  I[[k]]<-list()  
  for(i in 1:4){I[[k]][[i]] <- array(dim=c(2,2,5,5))}
  s2n_indvec = c(rep(1,5),rep(2,5))
  lambda_indVec = rep(c(1,2,3,4,5),2)
  for(j in 1:10){
    s2n_ind = s2n_indvec[j]
    lambda_ind = lambda_indVec[j]
    for(i in 1:4){
      I[[k]][[i]][,s2n_ind,lambda_ind,]=All[[j]][[i]][,s2n_ind,lambda_ind,]
    }  
  }
}

AllSums = I[[1]][[1]]
for(i in 2:10){
  AllSums = AllSums+I[[i]][[1]]
}
AllMeans = AllSums/10

####Mean error for correct ranks
rowMeans(AllMeans[2,2,,]) ###error increasing with regularization
rowMeans(AllMeans[2,1,,]) ###No substantive differences
rowMeans(AllMeans[1, 1,,])##error decreasing with regularization
rowMeans(AllMeans[1, 2,,])

##SD's,
means = array(dim=c(4,5,10))

for(i in 1:10){
  blah1 = rowMeans(I[[i]][[1]][1,1,,])
  blah2 = rowMeans(I[[i]][[1]][1,2,,])
  blah3 = rowMeans(I[[i]][[1]][2,1,,])
  blah4 = rowMeans(I[[i]][[1]][2,2,,])
  for(l in 1:5){
    means[1,l,i] = blah1[l]
    means[2,l,i] = blah2[l]
    means[3,l,i] = blah3[l]
    means[4,l,i] = blah4[l]
  }
}
##standard errors
apply(means,c(1,2),sd)/sqrt(10)

####ridge regression results (Section E)
I = list()
for(k in 1:10){
  if(k==1){ load("~/Revision Code/Revision2/RidgeRes/FullSimRidgeV2 1 .rda")} 
  if(k>1){
    load(paste("~/Revision Code/Revision2/RidgeRes/FullSimRidgeV2",k,".rda"))
  }
  I[[k]]<-list()  
  for(i in 1:4){I[[k]][[i]] <- array(dim=c(2,2,5,5))}
  s2n_indvec = c(rep(1,4),rep(2,4))
  lambda_indVec = rep(c(2,3,4,5),2)
  for(j in 1:8){
    s2n_ind = s2n_indvec[j]
    lambda_ind = lambda_indVec[j]
    for(i in 1:1){
      I[[k]][[i]][,s2n_ind,lambda_ind,]=All[[j]][[i]][,s2n_ind,lambda_ind,]
    }  
  }
}

AllSums = I[[1]][[1]]
for(i in 2:10){
  AllSums = AllSums+I[[i]][[1]]
}
AllMeans = AllSums/10


####Predictive error

rowMeans(AllMeans[2,1,,]) ###No substantive differences
rowMeans(AllMeans[2,2,,]) ###error increasing with regularization
rowMeans(AllMeans[1, 1,,])##error decreasing with regularization
rowMeans(AllMeans[1, 2,,])


##SD's,
means = array(dim=c(4,5,10))

for(i in 1:10){
  blah1 = rowMeans(I[[i]][[1]][1,1,,])
  blah2 = rowMeans(I[[i]][[1]][1,2,,])
  blah3 = rowMeans(I[[i]][[1]][2,1,,])
  blah4 = rowMeans(I[[i]][[1]][2,2,,])
  for(l in 1:5){
    means[1,l,i] = blah1[l]
    means[2,l,i] = blah2[l]
    means[3,l,i] = blah3[l]
    means[4,l,i] = blah4[l]
  }
}

apply(means,c(1,2),sd)/sqrt(10)


#Reduced rank X, independent Y (Section E)

I = list()
for(k in 1:10){
  if(k==1){ load("~/Revision Code/Revision2/IndepYRes2/FullSimIndepY_V3 1 .rda")} 
  if(k>1){
    load(paste("~/Revision Code/Revision2/IndepYRes2/FullSimIndepY_V3",k,".rda"))
  }
  I[[k]]<-list()  
  for(i in 1:4){I[[k]][[i]] <- array(dim=c(2,2,5,5))}
  s2n_indvec = c(rep(1,4),rep(2,4))
  lambda_indVec = rep(c(2,3,4,5),2)
  for(j in 1:8){
    s2n_ind = s2n_indvec[j]
    lambda_ind = lambda_indVec[j]
    for(i in 1:1){
      I[[k]][[i]][,s2n_ind,lambda_ind,]=All[[j]][[i]][,s2n_ind,lambda_ind,]
    }  
  }
}

AllSums = I[[1]][[1]]
for(i in 2:10){
  AllSums = AllSums+I[[i]][[1]]
}
AllMeans = AllSums/10


####Predictive error

rowMeans(AllMeans[2,1,,]) ###No substantive differences
rowMeans(AllMeans[2,2,,]) ###error increasing with regularization
rowMeans(AllMeans[1, 1,,])##error decreasing with regularization
rowMeans(AllMeans[1, 2,,])


##SD's,
means = array(dim=c(4,5,10))

for(i in 1:10){
  blah1 = rowMeans(I[[i]][[1]][1,1,,])
  blah2 = rowMeans(I[[i]][[1]][1,2,,])
  blah3 = rowMeans(I[[i]][[1]][2,1,,])
  blah4 = rowMeans(I[[i]][[1]][2,2,,])
  for(l in 1:5){
    means[1,l,i] = blah1[l]
    means[2,l,i] = blah2[l]
    means[3,l,i] = blah3[l]
    means[4,l,i] = blah4[l]
  }
}

apply(means,c(1,2),sd)/sqrt(10)


##########Rank cross-validation (Section F)

SSE = list()
for(k in 1:10){
    load(paste("~/Revision Code/Revision2/RankCV2/FullSimCV",k,".rda"))
  SSE[[k]]<-array(dim=c(2,2,5,5,5))
  s2n_indvec = c(rep(1,5),rep(2,5),rep(1,5),rep(2,5))
  lambda_indVec = rep(c(1,2,3,4,5),4)
  n_indvec = c(rep(1,10),rep(2,10))
  
  for(j in 1:20){
    s2n_ind = s2n_indvec[j]
    lambda_ind = lambda_indVec[j]
    n_ind = n_indvec[j]
      SSE[[k]][n_ind,s2n_ind,lambda_ind,,]=All[[j]][[1]][n_ind,s2n_ind,lambda_ind,,]
    }  
}

lambdaVec = c(0,0.5,1,5,50)
Rank = array(dim=c(10,2,2,5))
Lambda = array(dim=c(10,2,2,5))
for(k in 1:10){ for(j in 1:2){for(i in 1:2){for(r in 1:5){
indices <- which(as.matrix(SSE[[k]][j,i,,r,]==min(SSE[[k]][j,i,,r,])),arr.ind=TRUE)
Rank[k,j,i,r] <- indices[1,2]
Lambda[k,j,i,r] <- lambdaVec[indices[1,1]]
}}}}
I
Correct21 =0
Correct22 =0
Correct12 =0
Correct11 =0
Over21 =0
Over22 =0
Over12 =0
Over11 =0
Under21 =0
Under22 =0
Under12 =0
Under11 =0
for(r in 1:5){
  Correct21 = Correct21+sum(Rank[,2,1,r]==r)
  Correct22 = Correct22+sum(Rank[,2,2,r]==r)
  Correct12 = Correct12+sum(Rank[,1,2,r]==r)
  Correct11 = Correct11+sum(Rank[,1,1,r]==r)
  Over21 = Over21+sum(Rank[,2,1,r]>r)
  Over22 = Over22+sum(Rank[,2,2,r]>r)
  Over12 = Over12+sum(Rank[,1,2,r]>r)
  Over11 = Over11+sum(Rank[,1,1,r]>r)
  Under21 = Under21+sum(Rank[,2,1,r]<r)
  Under22 = Under22+sum(Rank[,2,2,r]<r)
  Under12 = Under12+sum(Rank[,1,2,r]<r)
  Under11 = Under11+sum(Rank[,1,1,r]<r)
}

c(Correct21,Under21,Over21)/50
c(Correct22,Under22,Over22)/50
c(Correct12,Under12,Over12)/50
c(Correct11,Under11,Over11)/50

mean(Lambda[,1,2,])
mean(Lambda[,2,1,])
mean(Lambda[,1,1,])
